<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <title>Fab Academy</title>
    <link rel="icon" href="img/fav.png" type="image/x-icon">

    <!-- Bootstrap -->
    <link href="css/bootstrap.min.css" rel="stylesheet">
    <link href="ionicons/css/ionicons.min.css" rel="stylesheet">

    <!-- main css -->
    <link href="css/style.css" rel="stylesheet">


    <!-- modernizr -->
    <script src="js/modernizr.js"></script>

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
</head>

<body>

    <!-- Preloader -->
    <div id="preloader">
        <div class="pre-container">
            <div class="spinner">
                <div class="double-bounce1"></div>
                <div class="double-bounce2"></div>
            </div>
        </div>
    </div>
    <!-- end Preloader -->

    <div class="container-fluid">
       <!-- box-header -->
        <header class="box-header">
            <div class="box-logo">
                <a href="index.html"><img src="img/logo.png" width="120" alt="Logo"></a>
            </div>
            <!-- box-nav -->
            <a class="box-primary-nav-trigger" href="#0">
                <span class="box-menu-text">Menu</span><span class="box-menu-icon"></span>
            </a>
            <!-- box-primary-nav-trigger -->
        </header>
        <!-- end box-header -->

        <!-- nav -->
        <nav>
            <ul class="box-primary-nav">
                <li class="box-label">MDEF Journal</li>

                <li><a href="index.html">Home</a></li>
                <li><a href="about.html">About me</a></li>
                <li><a href="reflection.html">Reflection</a>
                <li><a href="fabAcademy.html">Fab Academy</a></li> <i class="ion-ios-circle-filled color"></i></li>
                <li><a href="project.html">Master Project</a></li>

                <li class="box-label">Follow me</li>
                <li class="box-social"><a target="_blank" href="https://www.facebook.com/chingchia.jen"><i class="ion-social-facebook"></i></a></li>
                <li class="box-social"><a target="_blank" href="https://www.instagram.com/chingchiajen/?hl=zh-tw"><i class="ion-social-instagram-outline"></i></a></li>
                <li class="box-social"><a target="_blank" href="https://www.linkedin.com/in/ching-chia-renn-a85285159/"><i class="ion-social-linkedin"></i></a></li>
                <li class="box-social"><a target="_blank" href="#0"><i class="ion-social-youtube"></i></a></li>
            </ul>
        </nav>
        <!-- end nav -->
    </div>

    <!-- main-container -->
    <div class="container main-container">

        <div class="col-md-12">
            <p class="center"><img width="200" height="200" src="img/reflections/fabA/w12/fab-12.jpg" alt="" /></p>
            <h3 class="center">Interface and Application Programming</h3>
            <h5 class="center">22 April - 28 April 2020</h5>
            <p class="center">Tutors: Santiago Fuentemilla, Eduardo Chamorro, Xavi Domínguez, Óscar González</p>
            <div class="h-30"></div>
        </div>

        <div align="justify">

          <script src="https://cdnjs.cloudflare.com/ajax/libs/p5.js/0.5.14/p5.js"></script>
          <script src="https://s3-us-west-2.amazonaws.com/s.cdpn.io/837599/p5.speech.js"></script>
          <script src="https://unpkg.com/@webcomponents/webcomponentsjs@^2/webcomponents-bundle.js"></script>
          <script src="https://unpkg.com/tone"></script>
          <script src="https://unpkg.com/@tonejs/ui"></script>

          <script>
            var speech = new p5.Speech();
            var synth = new Tone.Synth().toMaster()

            var playing;
            var mouseclick = false;

            function setup(){
              var canvas = createCanvas(768, 256);
              canvas.parent('sketch-div');
              background(32);

            }

            function draw(){
              textSize(18);
              fill(50);
              text('You can click, draw, and play notes!', 230, 128);

              if (!mouseIsPressed) {
                fill(32, 50);
                rect(0, 0, 768, 256);
                mouseclick = false;
              } else if (mouseIsPressed && mouseclick == false && mouseButton === RIGHT) {
                background(32);
                mouseclick = true;
                }
                fill(255);
                noStroke();
                ellipse(mouseX, mouseY, 20, 20);
            }

            function mouseClicked(){
            var r = random(30, 300);
            textSize(24);
            if((mouseX >= 0) && (mouseX <= 95) && (mouseY >= 0) && (mouseY <= 256)){
            synth.triggerAttackRelease('C4', '4n')
            fill(255);
            ellipse(mouseX, mouseY, r, r);
            fill(32);
            text('C', mouseX + 10, mouseY - 10);
            }
            if((mouseX >= 96) && (mouseX <= 192) && (mouseY >= 0) && (mouseY <= 256)){
            synth.triggerAttackRelease('D4', '4n')
            fill(255);
            ellipse(mouseX, mouseY, r, r);
            fill(32);
            text('D', mouseX + 10, mouseY - 10);
            }
            if((mouseX >= 193) && (mouseX <= 289) && (mouseY >= 0) && (mouseY <= 256)){
            synth.triggerAttackRelease('E4', '4n')
            fill(255);
            ellipse(mouseX, mouseY, r, r);
            fill(32);
            text('E', mouseX + 10, mouseY - 10);
            }
            if((mouseX >= 290) && (mouseX <= 386) && (mouseY >= 0) && (mouseY <= 256)){
            synth.triggerAttackRelease('F4', '4n')
            fill(255);
            ellipse(mouseX, mouseY, r, r);
            fill(32);
            text('F', mouseX + 10, mouseY - 10);
            }
            if((mouseX >= 387) && (mouseX <= 483) && (mouseY >= 0) && (mouseY <= 256)){
            synth.triggerAttackRelease('G4', '4n')
            fill(255);
            ellipse(mouseX, mouseY, r, r);
            fill(32);
            text('G', mouseX + 10, mouseY - 10);
            }
            if((mouseX >= 484) && (mouseX <= 580) && (mouseY >= 0) && (mouseY <= 256)){
            synth.triggerAttackRelease('A4', '4n')
            fill(255);
            ellipse(mouseX, mouseY, r, r);
            fill(32);
            text('A', mouseX + 10, mouseY - 10);
            }
            if((mouseX >= 581) && (mouseX <= 677) && (mouseY >= 0) && (mouseY <= 256)){
            synth.triggerAttackRelease('B4', '4n')
            fill(255);
            ellipse(mouseX, mouseY, r, r);
            fill(32);
            text('B', mouseX + 10, mouseY - 10);
            }
            if((mouseX >= 678) && (mouseX <= 768) && (mouseY >= 0) && (mouseY <= 256)){
            synth.triggerAttackRelease('C5', '4n')
            fill(255);
            ellipse(mouseX, mouseY, r, r);
            fill(32);
            text('C', mouseX + 10, mouseY - 10);
            }
            }

          </script>
          <div id="sketch-div"></div>
          <div class="h-30"></div>

            <p>The fab academy this week was about interfaces and applications.
              It was a week which combined different knowledge and skills from the weeks of input and output devices in Fab Academy, but added the interfacing element.
              The assignment this week was to write an application that interfaces with an input and / or an output.</p>

            <h3>Processing</h3>
            <img width="100" src="img/reflections/fabA/w12/processingLogo.jpg" class="img-responsive" alt="" />
            <p><a target="_blank" href="https://processing.org/">Processing</a> is an open-source graphical library and integrated development environment (IDE) built for the electronic arts, new media art, and visual design communities with the purpose of teaching non-programmers the fundamentals of computer programming in a visual context.</p>
            <p>Processing uses the Java language, with additional simplifications such as additional classes and aliased mathematical functions and operations.</p>
            <p>There is a very complete documentation about Processing programming language in their official website (<a target="_blank" href="https://processing.org/reference/">here</a>).
              There are also many examples in the website (<a target="_blank" href="https://processing.org/examples/">here</a>), which are interesting and we can learn from them, also their <a target="_blank" href="https://processing.org/tutorials/">tutorial</a>.</p>

            <h3>Processing Connecting with Arduino</h3>
            <img src="img/reflections/fabA/w12/PA.png" class="img-responsive" alt="" />
            <h4>Serial Communication</h4>
            <p>The Arduino board can talk to the computer through the USB using the Serial port.
              </p>
            <h5>In Processing - myPort.read() & myPort.write()</h5>
            <p>In Processing we use "myPort.read()" to collect data from the serial port and use "myPort.write()" to send data to the serial port.</p>
            <h5>In Arduino - Serial.read() & Serial.write()</h5>
            <p>In Arduino we use "Serial.read()" to collect data from the serial port and use "Serial.write()" to send data to the serial port.</p>
            <h4>Import Library</h4>
            <p>In the Processing, the sketch would like to connect Arduino board with serial communication need to import the Serial library at the beginning like the picture shows below.</p>
            <img src="img/reflections/fabA/w12/importSerial.png" class="img-responsive" alt="" />
            <div class="h-30"></div>
            <p>The Serial library has already built inside the processing, and the PDF Export, Network, and DXF Export libraries are also distributed with Procesing.
              In addition, there are many contributed libraries can be downloaded individually.
              We can check their full of documentation and descriptions about all the libraries in the Processing official website (<a target="_blank" href="https://processing.org/reference/libraries/">here</a>).
              And the way of installing the libraries is shown by following pictures.</p>
            <img src="img/reflections/fabA/w12/addLibrary.png" class="img-responsive" alt="" />
            <div class="h-30"></div>
            <img src="img/reflections/fabA/w12/installLibrary.png" class="img-responsive" alt="" />
            <div class="h-30"></div>
            <div class="h-30"></div>

            <h4>Test 1 - Physical & Digital Button</h4>
            <p>In order to understand more clearly, I first went to see the processing Serial examples and I really looked into the examples especially the "SimpleWrite" and "SimpleRead".
              Then tried to modify and combine two of them.
              The idea of this practice is that pressing the digital button in processing, the sound will come out from the speaker and pressing the physical button, the sound will play by my laptop's speaker.</p>
            <img src="img/reflections/fabA/w12/diagram.jpg" class="img-responsive" alt="" />
            <div class="h-30"></div>
            <h5>Circuit</h5>
            <img src="img/reflections/fabA/w12/2.jpg" class="img-responsive" alt="" />
            <div class="h-30"></div>
            <h5>Processing Code</h5>
            <div class="code-container">
              <div class="incode">

                <p>import processing.sound.*;</p></p>
                <p>import processing.serial.*;</p>
                <div class="h-30"></div>
                <p>Serial myPort;</p>
                <p>int val;      // Data received from the serial port</p>

                <p>SinOsc sine;</p>
                <div class="h-30"></div>
                <p>void setup()</p>
                <p>{</p>
                  <p>size(200, 200);</p>
                  <p>String portName = Serial.list()[0];</p>
                  <p>myPort = new Serial(this, portName, 9600);</p>

                  <p>sine = new SinOsc(this);</p>
                  <p>sine.play();</p>
                <p>}</p>
                <div class="h-30"></div>
                <p>void draw()</p>
                <p>{
                  <p>if ( myPort.available() > 0) {  // If data is available,</p>
                    <p>val = myPort.read();         // read it and store it in val</p>
                  <p>}</p>
                  <p>background(255);             // Set background to white</p>
                  <p>if (val == 0) {              // If the serial value is 0,</p>
                    <p>sine.freq(0);</p>
                  <p>} else {                       // If the serial value is not 0,</p>
                    <p>sine.freq(262);            // C4</p>
                  <p>}</p>
                <div class="h-30"></div>
                  <p>if (mousePressed) {</p>
                    <p>fill(204);</p>
                    <p>myPort.write('H');</p>
                  <p>} else {</p>
                    <p>fill(0);</p>
                    <p>myPort.write('L');</p>
                  <p>}</p>

                  <p>rect(50, 50, 100, 100);</p>
                <p>}</p>

            </div>
            </div>
            <div class="h-30"></div>

            <h5>Arduino Code</h5>
            <div class="code-container">
              <div class="incode">

                <p>char val; // Data received from the serial port</p>
                <p>int switchPin = 4;</p>
                <p>int speaker = 9;</p>
                <div class="h-30"></div>
                <p>void setup() {</p>
                  <p>Serial.begin(9600);</p>
                  <p>pinMode(switchPin, INPUT);</p>
                  <p>pinMode(speaker, OUTPUT);</p>
                <p>}</p>
                <div class="h-30"></div>
                <p>void loop() {</p>
                  <p>while (Serial.available()) { // If data is available to read,</p>
                    <p>val = Serial.read(); // read it and store it in val</p>
                  <p>}</p>
                  <p>if (val == 'H') { // If H was received</p>
                    <p>tone(speaker, 262); // C4</p>
                  <p>} else {</p>
                    <p>noTone(speaker);</p>
                  <p>}</p>
                <div class="h-30"></div>
                  <p>if (digitalRead(switchPin) == HIGH) {  // If switch is ON,</p>
                    <p>Serial.write(1);               // send 1 to Processing</p>
                  <p>} else {                               // If the switch is not ON,</p>
                    <p>Serial.write(0);               // send 0 to Processing</p>
                  <p>}</p>

                  <p>delay(100);</p>
                <p>}</p>

            </div>
            </div>
            <div class="h-30"></div>

            <iframe src="https://player.vimeo.com/video/414134135" width="768" height="426" frameborder="0" allow="autoplay; fullscreen" allowfullscreen></iframe>
            <div class="h-30"></div>
            <div class="h-30"></div>

            <h4>Test 2 - LED Color Picker</h4>
            <p>In this practice I used the joystick as an input, RGB LED module as an output to connect the processing interface which is showing the colors.
              The way to change the RGB LED's light color is controlling the joystick to move the dot to the color you want and select the color in the interface.</p>
            <img src="img/reflections/fabA/w12/colors.jpg" class="img-responsive" alt="" />
            <h5>Tutorial: <a target="_blank" href="https://www.instructables.com/id/Control-RGB-LED-with-arduino-and-Processing/">Control RGB LED With Arduino and Processing</a></h5>
            <h5>Tutorial: <a target="_blank" href="https://lastminuteengineers.com/joystick-interfacing-arduino-processing/">How 2-Axis Joystick Works & Interface with Arduino + Processing</a></h5>
            <div class="h-30"></div>
            <h5>Circuit</h5>
            <img src="img/reflections/fabA/w12/3.jpg" class="img-responsive" alt="" />
            <div class="h-30"></div>
            <h5>Processing Code</h5>
            <div class="code-container">
              <div class="incode">

                <p>import processing.serial.*;</p>
                <p>Serial myPort;</p>
                <div class="h-30"></div>
                <p>int x; // A0</p>
                <p>int y; // A1</p>
                <p>int b; // pin 8</p>
                <p>PFont font;</p>
                <p>String val;</p>
                <p>PImage img;</p>
                <div class="h-30"></div>
                <p>void setup() {</p>
                  <p>size (465, 465) ;</p>
                  <p>img = loadImage("color.jpg");</p>
                  <p>String portName = Serial.list()[0];</p>
                  <p>myPort = new Serial(this, portName, 9600);</p>
                  <p>myPort.bufferUntil('\n');</p>
                <div class="h-30"></div>
                  <p>font = createFont("Arial", 16, true);</p>
                  <p>textFont (font, 16) ;</p>
                <p>}</p>
                <div class="h-30"></div>
                <p>void draw() {</p>
                  <p>image(img, 0, 0);</p>
                  <p>img.loadPixels();</p>
                <div class="h-30"></div>
                  <p>if (b == 1) {</p>
                    <p>fill(255, 0);</p>
                    <p>ellipse(x/2, y/2, 20, 20);</p>
                    <p>myPort.write("CL");</p>
                    <p>myPort.write(int(red(img.pixels[x/2+y/2*img.width])));</p>
                    <p>myPort.write(int(green(img.pixels[x/2+y/2*img.width])));</p>
                    <p>myPort.write(int(blue(img.pixels[x/2+y/2*img.width])));</p>
                  <p>} else {</p>
                    <p>fill(0);</p>
                    <p>ellipse(x/2, y/2, 10, 10);</p>
                  <p>}</p>
                  <p>text("AnalogX="+(1023-x)+" AnalogY="+(1023-y), 10, 20);</p>
                <p>}</p>
                <div class="h-30"></div>
                <p>void serialEvent( Serial myPort) {</p>
                  <p>val = myPort.readStringUntil('\n');</p>
                <div class="h-30"></div>
                  <p>if (val != null) {</p>
                    <p>val = trim(val);</p>
                <div class="h-30"></div>
                    <p>int[] vals = int(splitTokens(val, ","));</p>

                    <p>x = vals[0];</p>
                    <p>y = vals[1];</p>
                    <p>b = vals[2];</p>
                  <p>}</p>
                <p>}</p>

            </div>
            </div>
            <div class="h-30"></div>
            <h5>Arduino Code</h5>
            <div class="code-container">
              <div class="incode">

                <p>int xValue = 0 ; // read value of the X axis</p>
                <p>int yValue = 0 ; // read value of the Y axis</p>
                <p>int bValue = 0 ; // value of the button reading</p>
                <div class="h-30"></div>
                <p>int redPin   = 9;</p>
                <p>int greenPin = 10;</p>
                <p>int bluePin  = 11;</p>
                <div class="h-30"></div>
                <p>long int inByte;</p>
                <div class="h-30"></div>
                <p>void setup() {</p>
                  <p>Serial.begin(9600) ; // Open the serial port</p>
                  <p>pinMode(8, INPUT) ; // Configure Pin 8 as input</p>
                  <p>digitalWrite(8, HIGH);</p>
                  <p>pinMode(redPin,   OUTPUT);</p>
                  <p>pinMode(greenPin, OUTPUT);</p>
                  <p>pinMode(bluePin,  OUTPUT);</p>
                <p>}</p>
                <div class="h-30"></div>
                <p>int* getColor() {</p>
                  <p>int* color;</p>
                  <p>int i = 0;</p>
                  <p>while (i < 4) {</p>
                    <p>if (Serial.available() > 0) {</p>
                      <p>color[i] = Serial.read();</p>
                      <p>i++;</p>
                    <p>}</p>
                  <p>}</p>
                  <p>return color;</p>
                <p>}</p>
                <div class="h-30"></div>
                <p>void loop() {</p>
                  <p>xValue = analogRead(A0);</p>
                  <p>yValue = analogRead(A1);</p>
                  <p>bValue = digitalRead(8);</p>
                <div class="h-30"></div>
                  <p>Serial.print(xValue,DEC);</p>
                  <p>Serial.print(",");</p>
                  <p>Serial.print(yValue,DEC);</p>
                  <p>Serial.print(",");</p>
                  <p>Serial.print(!bValue);</p>
                  <p>Serial.print("\n");</p>
                <div class="h-30"></div>
                  <p>if (Serial.available() > 0) {</p>
                    <p>inByte = Serial.read();</p>
                <div class="h-30"></div>
                    <p>if (inByte == 'C') {</p>
                      <p>int* one;</p>
                      <p>one =  getColor();</p>
                      <p>setColor(one[1], one[2], one[3]);</p>
                    <p>}</p>
                  <p>}</p>
                  <p>delay(10);</p>
                <p>}</p>
                <div class="h-30"></div>
                <p>void setColor(int redVal, int greenVal, int blueVal) {</p>
                  <p>analogWrite(redPin, redVal);</p>
                  <p>analogWrite(bluePin, blueVal);</p>
                  <p>analogWrite(greenPin, greenVal);</p>
                <p>}</p>

            </div>
            </div>
            <div class="h-30"></div>

            <iframe src="https://player.vimeo.com/video/414134171" width="768" height="426" frameborder="0" allow="autoplay; fullscreen" allowfullscreen></iframe>
            <div class="h-30"></div>
            <div class="h-30"></div>

            <h4>Test 3 - Generating Sound & Shape by Sensing</h4>
            <p>In this practice I took a photoresistor (LDR) as an input sensor and collected the data by sensing the light value to control the shape and the frequency of the sound.
              I also tested the <a target="_blank" href="http://mrfeinberg.com/peasycam/">PeasyCam</a> library, which is a mouse driven camera-control library for 3D sketches, and <a target="_blank" href="https://en.wikipedia.org/wiki/Spherical_coordinate_system">Supershapes</a> code in this practice.</p>
            <img width="768" height="426" src="img/reflections/fabA/w12/supershape.gif" class="img-responsive" alt="" />
            <h5>Tutorial: <a target="_blank" href="https://www.youtube.com/watch?v=akM4wMZIBWg&t=1122s">3D Supershapes (youtube)</a></h5>
            <h5>Tutorial: <a target="_blank" href="http://paulbourke.net/geometry/supershape/">Supershapes (Superformula)</a></h5>
            <div class="h-30"></div>
            <h5>Circuit</h5>
            <img src="img/reflections/fabA/w12/1.jpg" class="img-responsive" alt="" />
            <div class="h-30"></div>
            <h5>Processing Code</h5>
            <div class="code-container">
              <div class="incode">

                <p>import processing.sound.*;</p>
                <p>import processing.serial.*;</p>
                <p>import peasy.*;</p>
                <div class="h-30"></div>
                <p>SinOsc sine;</p>

                <p>Serial myPort;</p>
                <p>String lecture = "0";</p>
                <p>float val = 0;</p>

                <p>PeasyCam cam;</p>

                <p>float m = 0;</p>
                <div class="h-30"></div>
                <p>void setup() {</p>
                  <p>size(600, 600, P3D);</p>

                  <p>sine = new SinOsc(this);</p>
                  <p>sine.play();</p>

                  <p>String portName = Serial.list()[0];</p>
                  <p>myPort = new Serial(this, portName, 9600);</p>

                  <p>cam = new PeasyCam(this, 600);</p>
                <p>}</p>
                <div class="h-30"></div>
                <p>float a =1 ;</p>
                <p>float b =1 ;</p>
                <div class="h-30"></div>
                <p>float supershape(float theta, float m, float n1, float n2, float n3) {</p>
                  <p>float t1 = abs((1/a)*cos(m*theta/4));</p>
                  <p>t1 = pow(t1, n2);</p>
                  <p>float t2 = abs((1/b)*sin(m*theta/4));</p>
                  <p>t2 = pow(t2, n3);</p>
                  <p>float t3 = t1 + t2;</p>
                  <p>float r = pow(t3, -1/n1);</p>
                  <p>return r;</p>
                <p>}</p>
                <div class="h-30"></div>
                <p>void draw() {</p>
                  <p>if (myPort.available() > 0) {</p>
                    <p>lecture = myPort.readStringUntil('\n');</p>
                    <div class="h-30"></div>
                    <p>if (lecture != null) {</p>
                      <p>lecture = trim(lecture);</p>
                      <p>val = Integer.parseInt(lecture);</p>
                      <p>float frequency = map(val, 750, 1000, 80.0, 1000.0);</p>
                      <p>sine.freq(frequency);</p>
                      <p>m = map(frequency, 80.0, 1000.0, 0, 15);</p>
                    <p>}</p>
                  <p>}</p>
                  <div class="h-30"></div>
                  <p>background(0);</p>
                  <p>fill(255);</p>
                  <p>lights();</p>
                  <p>float r = 200;</p>
                  <p>int total = 100;</p>
                  <p>for (int i = 0; i < total; i++) {</p>
                    <p>float lat = map(i, 0, total, -HALF_PI, HALF_PI);</p>
                    <p>float r2 = supershape(lat, m, 0.2, 1.7, 1.7);</p>
                    <div class="h-30"></div>
                    <p>for (int j = 0; j < total; j++) {</p>
                      <p>float lon = map(j, 0, total, -PI, PI);</p>
                      <p>float r1 = supershape(lon, m, 0.2, 1.7, 1.7);</p>
                      <div class="h-30"></div>
                      <p>float x = r * r1 * cos(lon) * r2 * cos(lat);</p>
                      <p>float y = r * r1 * sin(lon) * r2 * cos(lat);</p>
                      <p>float z = r * r2 * sin(lat);</p>
                      <p>stroke(255);</p>
                      <p>strokeWeight(3);</p>
                      <p>point(x, y, z);</p>
                    <p>}</p>
                  <p>}</p>
                <p>}</p>

            </div>
            </div>
            <div class="h-30"></div>
            <h5>Arduino Code</h5>
            <div class="code-container">
              <div class="incode">

                <p>void setup() {</p>
                  <p>pinMode(A0, INPUT);</p>
                  <p>Serial.begin(9600);</p>
                <p>}</p>
                <div class="h-30"></div>
                <p>void loop() {</p>
                  <p>int sensorVal = analogRead(A0);</p>
                  <p>Serial.println(sensorVal);</p>
                  <p>delay(100);</p>
                <p>}</p>

            </div>
            </div>
            <div class="h-30"></div>

            <iframe src="https://player.vimeo.com/video/414134267" width="768" height="426" frameborder="0" allow="autoplay; fullscreen" allowfullscreen></iframe>
            <div class="h-30"></div>
            <iframe src="https://player.vimeo.com/video/414134318" width="768" height="426" frameborder="0" allow="autoplay; fullscreen" allowfullscreen></iframe>
            <div class="h-30"></div>
            <div class="h-30"></div>

            <h3>P5.js</h3>
            <img width="100" src="img/reflections/fabA/w12/p5Logo.jpg" class="img-responsive" alt="" />
            <p><a target="_blank" href="https://p5js.org/get-started/">P5.js</a> is a JavaScript library for creative coding, with a focus on making coding accessible and inclusive for artists, designers, educators, beginners, and anyone else!
              And it's free and open-source.</p>
            <p>P5.js was created by Lauren McCarthy in 2003, which is an interpretation of Processing for today’s web. The p5.js community has the official support of the Processing Foundation.</p>
            <p>We can start creating the sketch with <a target="_blank" href="https://editor.p5js.org/">p5 Editor</a>.
              And also can check their <a target="_blank" href="https://p5js.org/examples/">Examples</a> and <a target="_blank" href="https://p5js.org/reference/">Reference</a>, there is complete documentation that provides amounts of resource for people to learn.</p>
            <h5>Tutorial: <a target="_blank" href="https://stephanmax.is/writing/generative-art-with-p5js">Generative Art with p5.js</a></h5>

            <h4>P5.js and HTML</h4>
            <p>P5.js is a JavaScript library that runs inside an HTML page.
              P5.js provides people think of the whole browser page as an sketchbook, including HTML5 objects for text, input, video, webcam, and sound.
              That means we can mix HTML content and a P5.js sketch, and we can mix regular JavaScript with P5.js code.</p>
            <h5>Tutorial: <a target="_blank" href="https://happycoding.io/tutorials/p5js/web">P5.js and Web Dev</a></h5>

            <h4>Teachable Machine with P5.js</h4>
            <p>In theis practice, I would like to try some Machine Learning stuff.
               I used <a target="_blank" href="https://teachablemachine.withgoogle.com/">Teachable Machine</a> to build up my image datasets by capturing the images from the webcam on my laptop so that I can get the datasets easily.</p>
            <h5>Tutorial: <a target="_blank" href="https://www.youtube.com/watch?v=kwcillcWOg0&t=670s">Teachable Machine: Image Classification</a></h5>

            <iframe src="https://player.vimeo.com/video/428244700" width="768" height="426" frameborder="0" allow="autoplay; fullscreen" allowfullscreen></iframe>
            <div class="h-30"></div>
            <p>Once finishing capturing the images, clicking "Train Model" to train the model, and then exploring the model by clicking the "Export Model".
              And there was a window shown up, I copied the p5.js code in that window and pasted it in the P5.js editor.</p>
            <img src="img/reflections/fabA/w12/TMcode.png" class="img-responsive" alt="" />
            <div class="h-30"></div>
            <p>Then in the P5.js editor, I added some script to let it show differnt emojis by recognizing the images.</p>
            <iframe src="https://player.vimeo.com/video/428244536" width="768" height="426" frameborder="0" allow="autoplay; fullscreen" allowfullscreen></iframe>
            <h5>Codepen: <a target="_blank" href="https://codepen.io/Ching-Chia/pen/yLeObeb">Teachable Machine with P5.js</a></h5>
            <div class="h-30"></div>

            <h3>Useful Link</h3>
            <ul>
                <li>Tutorial: <a target="_blank" href="https://www.youtube.com/user/shiffman">The Coding Train</a></li>
                <li>JavaScript library: <a target="_blank" href="https://p5js.org/">P5.js</a></li>
                <li>JavaScript library: <a target="_blank" href="https://tonejs.github.io/">Tone.js</a></li>
                <li>JavaScript library: <a target="_blank" href="https://threejs.org/">three.js</a></li>
                <li>JavaScript library: <a target="_blank" href="https://ml5js.org/">ml5.js</a></li>
                <li>JavaScript library: <a target="_blank" href="https://d3js.org/">D3.js</a></li>
              </ul>

            <h3>Files</h3>
            <ul>
              <li><a href="img/reflections/fabA/w12/button_sound.zip" download>Physical & Digital Button</a> Arduino + Processing code (.zip)</li>
              <li><a href="img/reflections/fabA/w12/joystick_color.zip" download>LED Color Picker</a> Arduino + Processing code (.zip)</li>
              <li><a href="img/reflections/fabA/w12/supershape_sound.zip" download>Generating Sound & Shape by Sensing</a> Arduino + Processing code (.zip)</li>
             </ul>

        </div>
        </div>



    <!-- end main-container -->


    <!-- footer -->
    <footer>
        <div class="container-fluid">
            <p class="copyright">Ching-Chia Renn © MDEF 2019-2020</p>
        </div>
    </footer>
    <!-- end footer -->

    <!-- back to top -->
    <a href="#0" class="cd-top"><i class="ion-android-arrow-up"></i></a>
    <!-- end back to top -->




    <!-- jQuery -->
    <script src="js/jquery-2.1.1.js"></script>
    <!--  plugins -->
    <script src="js/bootstrap.min.js"></script>
    <script src="js/menu.js"></script>
    <script src="js/animated-headline.js"></script>
    <script src="js/isotope.pkgd.min.js"></script>


    <!--  custom script -->
    <script src="js/custom.js"></script>

    <!-- google analytics  -->
    <script>
        (function (i, s, o, g, r, a, m) {
            i['GoogleAnalyticsObject'] = r;
            i[r] = i[r] || function () {
                (i[r].q = i[r].q || []).push(arguments)
            }, i[r].l = 1 * new Date();
            a = s.createElement(o),
                m = s.getElementsByTagName(o)[0];
            a.async = 1;
            a.src = g;
            m.parentNode.insertBefore(a, m)
        })(window, document, 'script', 'https://www.google-analytics.com/analytics.js', 'ga');

        ga('create', 'UA-76796224-1', 'auto');
        ga('send', 'pageview');
    </script>

</body>

</html>
